package com.example.controller;

import com.example.bean.DailyReport;
import com.example.bean.RespBean;
import com.example.service.DailyReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/dailyReport")
public class DailyReportController {
    @Autowired
    private DailyReportService dailyReportService;

    @PostMapping("/add")
    public RespBean addDailyReport(DailyReport dailyReport)
    {
        int result = dailyReportService.addDailyReport(dailyReport);
        if(result == 1)
        {
            if(dailyReport.getError() == 1)
                return new RespBean("success","有异常，请及时就医");
            else
                return new RespBean("success","添加成功");
        }
        else
            return new RespBean("error","添加失败");
    }

    @PostMapping("/update")
    public RespBean updateDailyReport(DailyReport dailyReport)
    {
        int result = dailyReportService.updateDailyReport(dailyReport);
        if(result == 1)
        {
            if(dailyReport.getError() == 1)
                return new RespBean("success","有异常，请及时就医");
            else
                return new RespBean("success","添加成功");
        }
        else
            return new RespBean("error","添加失败");
    }

    @PostMapping("/selectByUserid")
    public List<DailyReport> selectByUserid(String userid)
    {
        return dailyReportService.selectByUserid(userid);
    }
}
