import Vue from 'vue'

import Vuex from 'vuex'

Vue.use(Vuex)

export default new Vuex.Store({
    //这里放全局参数，比如用户登录信息
    state: {
        token: "helloVueX",
        name: "",
        age: ""
    },
    mutations: {
        //这里是set方法，比如对该数据的修改、增加、删除等等。
        //组件调用this.$store.commit('SET_TOKEN','new token')挂载方法
        SET_TOKEN: (state, token) => {
            state.token = token
            console.log(state.token);
        }
    },
    //getters 当前getters对象（可对对象进行二次更改），用于将getters下的其他getter拿来用,组件通过this.$store.getters.fullInfo拿来使用
    getters: {
        token: state => state.token,
        nameInfo(state) {
            return "姓名:" + state.name
        },
        fullInfo(state, getters) {
            return getters.nameInfo + '年龄:' + state.age
        }
    },
    //异步处理
//组件中使用this.$store.dispatch('aEdit','new TOKEN')
    actions: {
        QQlogin({commit}, token) {
            return new Promise((resolve, reject) => {
                setToken(token);         //把token存放到cookie里
                commit('SET_TOKEN', token)     //commit调用mutations 数据
                resolve()
            })
        },
        aEdit(context, payload) {
            return new Promise((resolve, reject) => {
                setTimeout(() => {
                    context.commit('SET_TOKEN', payload)
                    resolve()
                }, 2000)
            })
        }
    },
    modules: {

//这里是我自己理解的是为了给全局变量分组，所以需要写提前声明其他store文件，然后引入这里

    }

})
